/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.mappers.CityPlot;

import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.mappers.CityPlot.CityPlotShared.*;
import org.visnow.vn.lib.utils.graph3d.GenericGraph3DGUI;


/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    protected Parameters parameters = null;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT
     * modify this code. The content of this method is always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        basePanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        xComponentUI = new org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI();
        xExtentSlider = new org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeSlider();
        jPanel5 = new javax.swing.JPanel();
        yComponentUI = new org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI();
        yExtentSlider = new org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeSlider();
        jPanel2 = new javax.swing.JPanel();
        genericGraph3DGUI = new org.visnow.vn.lib.utils.graph3d.GenericGraph3DGUI();

        setMinimumSize(new java.awt.Dimension(150, 580));
        setPreferredSize(new java.awt.Dimension(200, 600));
        setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("block relative dimension and position");
        jLabel1.setMaximumSize(new java.awt.Dimension(215, 25));
        jLabel1.setMinimumSize(new java.awt.Dimension(215, 25));
        jLabel1.setPreferredSize(new java.awt.Dimension(215, 25));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 0);
        add(jLabel1, gridBagConstraints);

        basePanel.setMinimumSize(new java.awt.Dimension(135, 150));
        basePanel.addComponentListener(new java.awt.event.ComponentAdapter()
        {
            public void componentShown(java.awt.event.ComponentEvent evt)
            {
                basePanelComponentShown(evt);
            }
        });
        basePanel.setLayout(new java.awt.GridBagLayout());

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("x"));
        jPanel4.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel4.add(xComponentUI, gridBagConstraints);

        xExtentSlider.setPaintLabels(true);
        xExtentSlider.setPaintTicks(true);
        xExtentSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                xExtentSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(xExtentSlider, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        basePanel.add(jPanel4, gridBagConstraints);

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("y"));
        jPanel5.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel5.add(yComponentUI, gridBagConstraints);

        yExtentSlider.setPaintLabels(true);
        yExtentSlider.setPaintTicks(true);
        yExtentSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                yExtentSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel5.add(yExtentSlider, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        basePanel.add(jPanel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(basePanel, gridBagConstraints);

        jPanel2.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.3;
        add(jPanel2, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(genericGraph3DGUI, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void basePanelComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_basePanelComponentShown
    {//GEN-HEADEREND:event_basePanelComponentShown

    }//GEN-LAST:event_basePanelComponentShown

    private void xExtentSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_xExtentSliderStateChanged
    {//GEN-HEADEREND:event_xExtentSliderStateChanged
        parameters.set(X_RANGE, new float[] {xExtentSlider.getBottomValue() / 100f,
                                             xExtentSlider.getTopValue() / 100f});
        parameters.set(ADJUSTING, xExtentSlider.isAdjusting());
    }//GEN-LAST:event_xExtentSliderStateChanged

    private void yExtentSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_yExtentSliderStateChanged
    {//GEN-HEADEREND:event_yExtentSliderStateChanged
        parameters.set(Y_RANGE, new float[] {yExtentSlider.getBottomValue() / 100f,
                                             yExtentSlider.getTopValue() / 100f});
        parameters.set(ADJUSTING, yExtentSlider.isAdjusting());
    }//GEN-LAST:event_yExtentSliderStateChanged

    public void setParameters(Parameters params)
    {
        parameters = params;
        genericGraph3DGUI.setParameters(parameters);
        xComponentUI.setComponentFeature(parameters.get(X_COMPONENT));
        yComponentUI.setComponentFeature(parameters.get(Y_COMPONENT));
    }

    public GenericGraph3DGUI getGenericGraph3DGUI()
    {
        return genericGraph3DGUI;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel basePanel;
    private org.visnow.vn.lib.utils.graph3d.GenericGraph3DGUI genericGraph3DGUI;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI xComponentUI;
    private org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeSlider xExtentSlider;
    private org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI yComponentUI;
    private org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeSlider yExtentSlider;
    // End of variables declaration//GEN-END:variables
}
